<template>
  <bh-geofocus-filter-ui
    :geofocus="geofocus"
    :selected="selected"
    @changed="onChanged"
  />
</template>

<script>
export default {
  name: 'BhGeofocusFilter',
  // fetchOnServer: process.env.NODE_ENV !== 'development',
  data: () => ({
    geofocusList: [],
  }),
  async fetch() {
    try {
      this.geofocusList = await this.$dataService.getGeofocus();
    } catch (error) {
      const query = { mid: 'geofocus.fetch.error' };

      if (process.server) {
        this.$nuxt.context.redirect('/server-error', query);
      }
      if (process.client) {
        this.$router.push({ path: '/server-error', query });
      }
    }
  },
  computed: {
    active() {
      return this.$store.getters['filters/getActiveGeofocus'];
    },
    geofocus() {
      return this.geofocusList.map((geofocus) => ({
        ...geofocus,
        disabled: !this.active.has(geofocus.code),
      }));
    },
    selected() {
      const selected = this.$store.getters['filters/getSelectedGeofocus'];
      return this.geofocus.filter((geofocus) => {
        return selected.includes(geofocus.code);
      });
    },
  },
  methods: {
    onChanged(selectedGeofocus) {
      const selected = selectedGeofocus.map(({ code }) => code);
      this.$store.dispatch('filters/setSelectedGeofocus', selected);
      this.$emit('changed');
    },
  },
};
</script>
